package PreProcessing;

import org.jsoup.Jsoup;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class PreProcessing {
    private static final String rootF = "/media/Master/";
    private static List<String> stopWords;

    public static void main(String[] args) throws Exception {
        initStopWords();
        File root = new File(rootF + "LOS/");
        for(String f1 : root.list()) {
            File folder1 = new File(root + "/" + f1);
            for(String f2 : folder1.list()) {
                File folder2 = new File(root + "/" + f1 + "/" + f2);
                for(String f3 : folder2.list()) {
                    File folder3 = new File(root + "/" + f1 + "/" + f2 + "/" + f3);
                    for(String file : folder3.list()) {
                        if(!file.endsWith(".processed")) {
                            try {
                                FileInputStream fileInputStream = new FileInputStream(root + "/" + f1 + "/" + f2 + "/" + f3 + "/" + file);
                                DataInputStream in = new DataInputStream(fileInputStream);
                                BufferedReader br = new BufferedReader(new InputStreamReader(in));

                                try {
                                    FileWriter fstream = new FileWriter(root + "/" + f1 + "/" + f2 + "/" + f3 + "/" + file + ".processed");
                                    BufferedWriter out = new BufferedWriter(fstream);
                                    String line;
                                    String lines = "";
                                    while((line = br.readLine()) != null) {
                                        if(!line.equalsIgnoreCase("\n")) {
                                            lines += line;
                                        }
                                    }
                                    String txt = html2text(lines);
                                    String letters = removeNotLettersAndStopWords(txt);
                                    out.write(letters);
                                    out.close();
                                }
                                catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }
                            catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }
                }
            }
        }
    }

    public static String html2text(String html) {
        //String clean = Jsoup.clean(html, new Whitelist());
//        String text = "";
//        Element title = Jsoup.parse(html).head().tagName("title");
//        if(title != null) {
//            text += title.text() + "\n";
//        }
//        Element body = Jsoup.parse(html).body();
//        if(body != null) {
//            String bodyStr = body.text();
//            text += bodyStr;
//        }
        return Jsoup.parse(html).text();
    }

    public static String removeNotLettersAndStopWords(String text) {
        String lowercase = text.toLowerCase();

        String allowedChars = "";
        for(int i = 0; i < lowercase.length(); i++) {
            int numVal = (int)lowercase.charAt(i);
            if(String.valueOf(lowercase.charAt(i)).equalsIgnoreCase("&")) {
                String test = "";
                int j = i+1;
                while(!String.valueOf(lowercase.charAt(j)).equalsIgnoreCase(";") && j < i+7) {
                    test += String.valueOf(lowercase.charAt(j));
                    j++;
                }
                if(test.equalsIgnoreCase("aring")) {
                    allowedChars += "å";
                    i += 6;
                }
                else if(test.equalsIgnoreCase("aelig")) {
                    allowedChars += "æ";
                    i += 6;
                }
                else if(test.equalsIgnoreCase("oslash")) {
                    allowedChars += "ø";
                    i += 7;
                }
            }
            else if((numVal <= 122 && numVal >= 97) ||                      //(lowercase) letters
                //(numVal <= 57 && numVal >= 48) ||                       //numbers
                (numVal <= 255 && numVal >= 192) ||                     //special chars as æøå etc
                (numVal == 32))                                         //space

            {
                allowedChars += lowercase.charAt(i);
            }
            else {
                allowedChars += " ";
            }
        }

        String[] words = allowedChars.split("\\s+");
        List<String> wordlist = new ArrayList<String>();
        for(int j = 0; j < words.length; j++) {
            if(!stopWords.contains(words[j]) && words[j].length() > 1) {  //remove stopwords and remove single characters
                wordlist.add(words[j]);
            }
        }

        String last = wordlist.toString();
        last = last.replaceAll(",", "");                    //remove all commas
        last = last.replaceAll("\\[|\\]", "");              //remove the [] that come at the start and end

        return last;
    }

    //public static void remove

    public static void initStopWords() {
        stopWords = new ArrayList<String>();
        try {
            FileInputStream fileInputStream = new FileInputStream(rootF + "StopWords/stop.txt");
            DataInputStream in = new DataInputStream(fileInputStream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in, "UTF8"));

            String line;
            while((line = br.readLine()) != null) {
                if(line.charAt(0) == 32) {

                }
                else {
                    String[] words = line.split(" +");
                    stopWords.add(words[0]);
                }
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}